package quicksort;

public class QuickSort {
    public static final int THRESHOLD = 40;
    
    private static void selectionSort(int[] list,int start,int end) {
        for (int i = start; i < end; i++) {
            // Find the minimum in the list[start..end]
            int currentMin = list[i];
            int currentMinIndex = i;

            for (int j = i + 1; j <= end; j++) {
                if (currentMin > list[j]) {
                    currentMin = list[j];
                    currentMinIndex = j;
                }
            }

            // Swap list[i] with list[currentMinIndex] if necessary;
            if (currentMinIndex != i) {
                list[currentMinIndex] = list[i];
                list[i] = currentMin;
            }
        }
    }
    
    private static int partition(int[] list,int start,int end) {
        // Use the element at end as the pivot
        int pivot = list[end];

        // Main loop
        int i = start-1;
        for(int j = start;j<end;j++) {
            // Move any small numbers you find to the left side of the list
            if(list[j] <= pivot) {
                i++;
                int temp = list[i];
                list[i] = list[j];
                list[j] = temp;
            }
        }
        // Move the pivot to the middle
        list[end] = list[i+1];
        list[i+1] = pivot;
        // Return the location of the pivot
        return i+1;
    }
    
    private static void quicksort(int[] list,int start,int end) {
        if(end - start < THRESHOLD)
            selectionSort(list,start,end);
        else {
            int mid = partition(list,start,end);
            quicksort(list,start,mid-1);
            quicksort(list,mid+1,end);
        }
    }
    
    public static void sort(int[] list) {
        quicksort(list,0,list.length-1);
    }
}
