package quicksort;

import java.io.File;
import java.util.Scanner;

public class TestQuicksort {
    public static int[] readNumbers(String fileName) {
        Scanner input = null;
        try {
            input = new Scanner(new File(fileName));
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        // We need to count the number of numbers first. We will read
        // through the file once simply to count how many numbers are
        // there...
        int N = 0;
        while (input.hasNextInt()) {
            int unused = input.nextInt();
            N++;
        }
        input.close();

        // Once we know how many numbers are in the file we can create an
        // array to hold them.
        int[] A = new int[N];

        // Now we have to read through the file again to put the numbers
        // into the array.
        try {
            input = new Scanner(new File(fileName));
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        int n = 0; // Where the next number will go.
        while (input.hasNextInt()) {
            A[n] = input.nextInt();
            n++;
        }
        input.close();

        return A;
    }
    
    public static void main(String[] args) {
        int[] A = readNumbers("numbers.txt");
        QuickSort.sort(A);
        
        Scanner input = new Scanner(System.in);
        System.out.print("Enter a number to search for or 1000 to quit:");
        int x = input.nextInt();
        while(x < 1000) {
            int n = BinarySearch.find(A,x);
            System.out.println(x+" is in location "+n);
            
            System.out.print("Enter a number to search for or 1000 to quit:");
            x = input.nextInt();
        }
    }
}
